
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_BUF		10000
#define TAB_SPACE	8

   const char*	text1 = 
   "/* ctors and dtors arrays -- to be used by runtime system */\n"
   "/*   to call static constructors and destructors          */\n"
   "/*                                                        */\n"
   "/* NOTE: Use a C compiler to compile this file. If you    */\n"
   "/*       are using GNU C++, be sure to use compile this   */\n"
   "/*       file using GNU C and the -traditional flag.      */\n"
   "\n"
   "typedef void (*VOIDFUNCPTR) (); /* ptr to function returning void */\n"
   "\n";

   const char*	text2 =
   "\n"
   "extern VOIDFUNCPTR _ctors[];\n"
   "VOIDFUNCPTR _ctors[] =\n"
   "    {\n";

   const char*	text3 =
   "    0\n"
   "    };\n"
   "\n";

   const char*	text4 =
   "\n"
   "extern VOIDFUNCPTR _dtors[];\n"
   "VOIDFUNCPTR _dtors[] =\n"
   "    {\n";

   const char*	text5 =
   "    0\n"
   "    };\n";

   int main (int argc, char *argv[])
   {
      char 	buf[MAX_BUF + 1];
      char	init[100][80];
      char	fini[100][80];
      int	initnum = 0;
      int	fininum = 0;
      int	i;
      char*	p;
      char*	p2;
      FILE*	inp;
      FILE*	out;
   
      /* open input and output */
      inp = stdin;
      out = stdout;
      if ((inp == NULL) || (out == NULL)) {
         printf ("error: file open\n");
      }
   
      /* look for global symbols which start with */
      while (!feof (inp)) {
         if (fgets (buf, MAX_BUF, inp) != NULL) {
            /* make a list of initiators */
            if ((initnum < 100) && 
               (((p = strstr (buf, "_GLOBAL_$I")) != NULL) ||
               ((p = strstr (buf, "_GLOBAL__I")) != NULL))) {
               if (((p2 = strchr (p, ' ')) != NULL) ||
                  ((p2 = strchr (p, '\n')) != NULL) ||
                  ((p2 = strchr (p, '\t')) != NULL)) {
                  *p2 = '\0';
               }
               strncpy (init[initnum++], p, 80);
            }
         /* now make a list of terminators */
            if ((fininum < 100) && 
               (((p = strstr (buf, "_GLOBAL_$D")) != NULL) ||
               ((p = strstr (buf, "_GLOBAL__D")) != NULL))) {
               if (((p2 = strchr (p, ' ')) != NULL) ||
                  ((p2 = strchr (p, '\n')) != NULL) ||
                  ((p2 = strchr (p, '\t')) != NULL)) {
                  *p2 = '\0';
               }
               strncpy (fini[fininum++], p, 80);
            }
         }
      }
   
      /* write header */
      fputs (text1, out);
   
      /* write initialitor declarations */
      for (i = 0; i < initnum; i++) {
         fputs ("void ", out);
         fputs (init[i], out);
         fputs ("();\n", out);
      }
   
      /* write text 2 */
      fputs (text2, out);
   
      /* write initialitor list */
      for (i = 0; i < initnum; i++) {
         fputs ("    ", out);
         fputs (init[i], out);
         fputs (",\n", out);
      }
   
      /* write text 3 */
      fputs (text3, out);
   
   
      /* write terminator declarations */
      for (i = 0; i < fininum; i++) {
         fputs ("void ", out);
         fputs (fini[i], out);
         fputs ("();\n", out);
      }
   
      /* write text 2 */
      fputs (text4, out);
   
      /* write terminator list */
      for (i = 0; i < fininum; i++) {
         fputs ("    ", out);
         fputs (fini[i], out);
         fputs (",\n", out);
      }
   
      /* write footer */
      fputs (text5, out);
   	
      exit (0);
      return 0;
   }
