/*------------ FrvRes.c, By B. Mours Sept 29, 2000 --------------------------*/
/* This object compute the mean, rms and residual value for each 
   individual vector element for a set of vectors.
   The mean and rms are computed on a periodic basis */
/*-------------------------------------------------------------------*/
#ifndef FRVRES
#define FRVRES

#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE
#endif

#include "Frv.h"

#ifdef __cplusplus
extern "C" {
#endif

struct FrvRes {
                             /*--------------------- input data -------------*/
  int    period;             /* period used to compute the means and rms     */
  double scale;              /* scaling factor apply to the residual         */
                             /*------------------- internal data ------------*/
  char   *name;              /* object name; copy of vector name             */
                             /* ------------output-------------------------  */
  FrVect *sum;               /* sum                                          */
  FrVect *sum2;              /* sum of the squared value                     */
  FrVect *mean;              /* average amplitude                            */
  FrVect *oneOverRms;        /* invers of the rms vector                     */
  FrVect *residual;          /* residual[i] = scale*(value[i]-mean[i])/rms[i]*/
  long nCall;                /* number of fft computed                       */
};

typedef struct FrvRes FrvRes;

void    FrvResFree(FrvRes *rms);
int     FrvResIni(FrvRes *rms, FrVect *vect);
FrvRes* FrvResNew(int duration, double scale);
int     FrvResProc(FrvRes *rms, FrVect *vect);

#ifdef __cplusplus
}
#endif

#endif
